import BN from 'bn.js';
import { DocumentNode } from 'graphql';
import { Address, Arc, IGenesisProtocolParams, IJoinProposalState, IPluginState, IProposalBaseCreateOptions, ITransaction, ProposalPlugin, transactionErrorHandler, transactionResultHandler } from '../../index';
export interface IJoinState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteParams: IGenesisProtocolParams;
        fundingToken: Address;
        minFeeToJoin: BN;
        memberReputation: BN;
        fundingGoal: BN;
        fundingGoalDeadline: Date;
    };
}
export interface IProposalCreateOptionsJoin extends IProposalBaseCreateOptions {
    fee: BN;
}
export interface IInitParamsJoin {
    daoId: string;
    votingMachine: string;
    votingParams: string[];
    voteOnBehalf: string;
    voteParamsHash: string;
    fundingToken: string;
    minFeeToJoin: number;
    memberReputation: number;
    fundingGoal: number;
    fundingGoalDeadline: number;
}
export declare class Join extends ProposalPlugin<IJoinState, IJoinProposalState, IProposalCreateOptionsJoin> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static initializeParamsMap(initParams: IInitParamsJoin): (string | number | string[])[];
    static itemMap(context: Arc, item: any, queriedId?: string): IJoinState | null;
    private static fragmentField;
    createProposalTransaction(options: IProposalCreateOptionsJoin): Promise<ITransaction>;
    createProposalTransactionMap(): transactionResultHandler<any>;
    createProposalErrorHandler(options: IProposalCreateOptionsJoin): transactionErrorHandler;
}
