import { DocumentNode } from 'graphql';
import { Address, Arc, IGenesisProtocolParams, IPluginState, IProposalBaseCreateOptions, ITransaction, ProposalPlugin, transactionErrorHandler, transactionResultHandler } from '../../index';
import { ITokenTradeProposalState } from './proposal';
export interface ITokenTradeState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteParams: IGenesisProtocolParams;
    };
}
export interface IProposalCreateOptionsTokenTrade extends IProposalBaseCreateOptions {
    sendTokenAddress: Address;
    sendTokenAmount: number;
    receiveTokenAddress: Address;
    receiveTokenAmount: number;
    descriptionHash: string;
}
export interface IInitParamsTT {
    daoId: string;
    votingMachine: string;
    votingParams: string[];
    voteOnBehalf: string;
    voteParamsHash: string;
}
export declare class TokenTrade extends ProposalPlugin<ITokenTradeState, ITokenTradeProposalState, IProposalCreateOptionsTokenTrade> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static initializeParamsMap(initParams: IInitParamsTT): (string | string[])[];
    static itemMap(context: Arc, item: any, queriedId?: string): ITokenTradeState | null;
    private static fragmentField;
    createProposalTransaction(options: IProposalCreateOptionsTokenTrade): Promise<ITransaction>;
    createProposalTransactionMap(): transactionResultHandler<any>;
    createProposalErrorHandler(options: IProposalCreateOptionsTokenTrade): transactionErrorHandler;
}
